package com.ynet.life.services.http;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.gene.log.GENELog;
import com.ynet.gene.service.GENEService;
import com.ynet.util.crypt.Base64;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.util.HashMap;
import java.util.StringTokenizer;
import sun.net.www.protocol.http.HttpURLConnection;

/* loaded from: com_ynet_life_services_http.jar:com/ynet/life/services/http/HttpMerCommService.class */
public class HttpMerCommService extends GENEService {
    private String reqProxyIP;
    private String useProxyAuthor;
    private String proxyUserName;
    private String proxyUserPass;
    private String httpURL;
    private String reqHead;
    private int reqProxyPort = -1;
    private String reqMethod = "POST";
    private int maxConnection = 10;
    public int curConnection = 0;

    public HttpMerCommService() {
    }

    public HttpMerCommService(String arg1) throws IOException {
        super.setName(arg1);
    }

    public String getValueFromDatas(String dataName, Object dataColl) throws GENEException {
        if (dataName == null || dataColl == null) {
            return null;
        }
        if (dataColl instanceof KeyedCollection) {
            return (String) ((KeyedCollection) dataColl).getDataValue(dataName);
        }
        return (String) ((Context) dataColl).getDataValue(dataName);
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v4 */
    /* JADX WARN: Type inference failed for: r0v5, types: [java.lang.Throwable] */
    /* JADX WARN: Type inference failed for: r0v66 */
    /* JADX WARN: Type inference failed for: r0v67, types: [java.lang.Throwable] */
    /* JADX WARN: Type inference failed for: r0v69 */
    /* JADX WARN: Type inference failed for: r0v7 */
    public String sendAndWait(String msg, int timeOut, String merURL, HashMap msgData) throws GENEException {
        InputStream input;
        InputStream input2 = null;
        OutputStream output = null;
        try {
            try {
                this.httpURL = merURL;
                if (!"post".equalsIgnoreCase(this.reqMethod) && msg != null && msg.length() > 0) {
                    this.httpURL = String.valueOf(this.httpURL) + "?" + msg;
                }
                HttpURLConnection reqConnection = new URL(this.httpURL).openConnection();
                if (this.useProxyAuthor != null && this.useProxyAuthor.trim().equalsIgnoreCase("true")) {
                    if (this.reqProxyIP != null && this.reqProxyIP.trim().length() != 0) {
                        System.getProperties().put("proxySet", "true");
                        System.getProperties().put("proxyHost", this.reqProxyIP);
                        System.getProperties().put("proxyPort", new StringBuilder().append(this.reqProxyPort).toString());
                    }
                    if (this.proxyUserName != null && this.proxyUserName.trim().length() != 0) {
                        reqConnection.setRequestProperty("Proxy-Authorization", new String(Base64.encode((String.valueOf(this.proxyUserName) + ":" + this.proxyUserPass).getBytes())));
                        reqConnection.setRequestProperty("Proxy-Connection", "Keep-Alive");
                    }
                }
                int contentLength = (msg == null || msg.length() <= 0) ? 0 : msg.getBytes().length;
                if (this.reqHead != null) {
                    StringTokenizer stName = new StringTokenizer(this.reqHead, "|");
                    while (stName.hasMoreTokens()) {
                        String reqMessage = (String) stName.nextElement();
                        int idx = reqMessage.indexOf(":");
                        String reqName = reqMessage.substring(0, idx);
                        String reqValue = reqMessage.substring(idx + 1, reqMessage.length());
                        reqConnection.setRequestProperty(reqName, reqValue);
                    }
                }
                reqConnection.setRequestMethod(this.reqMethod.toUpperCase());
                reqConnection.addRequestProperty("Content-Length", String.valueOf(contentLength));
                reqConnection.setDoInput(true);
                reqConnection.setDoOutput(true);
                try {
                    OutputStream output2 = reqConnection.getOutputStream();
                    reqConnection.connect();
                    if ("post".equalsIgnoreCase(this.reqMethod) && msg != null && msg.length() > 0) {
                        output2.write(msg.getBytes());
                        output2.close();
                    }
                    switch (reqConnection.getResponseCode()) {
                        case 200:
                            break;
                        case 301:
                        case 302:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "重定向!" + reqConnection.getResponseMessage());
                            break;
                        case 400:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "错误请求!" + reqConnection.getResponseMessage());
                            break;
                        case 401:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "请求需要用户验证!" + reqConnection.getResponseMessage());
                            break;
                        case 403:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "请求已被服务接受,但是被拒绝处理!" + reqConnection.getResponseMessage());
                            break;
                        case 404:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "FileNotFound!" + reqConnection.getResponseMessage());
                            break;
                        case 405:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "所使用的请求方法不被允许通过!" + reqConnection.getResponseMessage());
                            break;
                        case 407:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "Proxy Authentication Required!" + reqConnection.getResponseMessage());
                            break;
                        case 411:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "服务器拒绝接受没有定义Content-Length字段的请求!" + reqConnection.getResponseMessage());
                            break;
                        case 415:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "请求数据格式不被请求的资源支持!" + reqConnection.getResponseMessage());
                            break;
                        case 500:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "服务器内部错误!" + reqConnection.getResponseMessage());
                            break;
                        case 501:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "服务器没有相应的执行动作来完成当前请求!" + reqConnection.getResponseMessage());
                            break;
                        case 503:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "服务器不可用!" + reqConnection.getResponseMessage());
                            break;
                        case 505:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "Http Version NOT SUPPORTED!" + reqConnection.getResponseMessage());
                            break;
                        default:
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.DEBUG, 0, "Http连接请求出错!" + reqConnection.getResponseMessage());
                            break;
                    }
                    try {
                        input = reqConnection.getInputStream();
                    } catch (IOException e) {
                        InputStream errorStream = reqConnection.getErrorStream();
                        input = errorStream;
                        if (errorStream == null) {
                            reqConnection.disconnect();
                            GENELog.log(GENEConstance.GENE_COMM, GENELog.ERROR, 0, "Get the ErrorStream error！Caused By " + e.getMessage());
                            throw new GENEException(e);
                        }
                    }
                    ReceiveMsg rec = new ReceiveMsg(input, msgData);
                    rec.beginRun();
                    rec.waitForData(timeOut);
                    input.close();
                    reqConnection.disconnect();
                    try {
                        String retMessage = rec.getMessage();
                        ?? r0 = this;
                        synchronized (r0) {
                            this.curConnection--;
                            r0 = r0;
                            if (input != null) {
                                try {
                                    input.close();
                                } catch (Exception unused) {
                                }
                            }
                            if (output2 != null) {
                                output2.close();
                            }
                            return retMessage;
                        }
                    } catch (GENEException e2) {
                        GENELog.log(GENEConstance.GENE_COMM, GENELog.ERROR, 0, "Read the message error! Caused By " + e2.getMessage());
                        throw new GENEException(e2.getMessage());
                    }
                } catch (IOException e22) {
                    GENELog.log(GENEConstance.GENE_COMM, GENELog.ERROR, 0, "服务器无响应或所输入的服务器地址错误！" + e22.getMessage());
                    throw new GENEException("服务器无响应或所输入的服务器地址错误！" + e22.getMessage());
                }
            } catch (Throwable th) {
                ?? r02 = this;
                synchronized (r02) {
                    this.curConnection--;
                    r02 = r02;
                    if (0 != 0) {
                        try {
                            input2.close();
                        } catch (Exception unused2) {
                            throw th;
                        }
                    }
                    if (0 != 0) {
                        output.close();
                    }
                    throw th;
                }
            }
        } catch (IOException ee) {
            GENELog.log(GENEConstance.GENE_COMM, GENELog.ERROR, 0, ee.getMessage());
            throw new GENEException(ee.getMessage());
        }
    }

    public void setReqMethod(String value) {
        this.reqMethod = value;
    }

    public void setReqProxyIP(String value) {
        this.reqProxyIP = value;
    }

    public void setReqProxyPort(int value) {
        this.reqProxyPort = value;
    }

    public void setUseProxyAuthor(String value) {
        this.useProxyAuthor = value;
    }

    public void setProxyUserName(String value) {
        this.proxyUserName = value;
    }

    public void setProxyUserPass(String value) {
        this.proxyUserPass = value;
    }

    public void setHttpURL(String value) {
        this.httpURL = value;
    }

    public void setReqHead(String head) {
        this.reqHead = head;
    }

    public int getMaxConnection() {
        return this.maxConnection;
    }

    public void setMaxConnection(int maxConnection) {
        this.maxConnection = maxConnection;
    }

    public String getHttpURL() {
        return this.httpURL;
    }

    public String getProxyUserName() {
        return this.proxyUserName;
    }

    public String getProxyUserPass() {
        return this.proxyUserPass;
    }

    public String getReqHead() {
        return this.reqHead;
    }

    public String getReqMethod() {
        return this.reqMethod;
    }

    public String getReqProxyIP() {
        return this.reqProxyIP;
    }

    public int getReqProxyPort() {
        return this.reqProxyPort;
    }

    public String getUseProxyAuthor() {
        return this.useProxyAuthor;
    }

    /* loaded from: com_ynet_life_services_http.jar:com/ynet/life/services/http/HttpMerCommService$ReceiveMsg.class */
    public class ReceiveMsg implements Runnable {
        private InputStream in;
        public Thread readingThread;
        private int readLen;
        public HashMap msgData;
        public boolean isStop = false;
        public boolean readOK = false;
        private byte[] buffer = new byte[2048];

        public ReceiveMsg(InputStream in, HashMap msgData) {
            this.in = in;
            this.msgData = msgData;
        }

        @Override // java.lang.Runnable
        public void run() {
            int len;
            byte[] buf = new byte[256];
            this.readLen = 0;
            while (!this.isStop) {
                try {
                    len = this.in.read(buf);
                } catch (Exception e) {
                    GENELog.log(GENEConstance.GENE_COMM, GENELog.ERROR, 0, e.getMessage());
                }
                if (len <= 0) {
                    readInputOk(this);
                    break;
                }
                if (len + this.readLen >= this.buffer.length) {
                    byte[] tmp = new byte[this.buffer.length + 1024];
                    System.arraycopy(this.buffer, 0, tmp, 0, this.readLen);
                    this.buffer = tmp;
                }
                System.arraycopy(buf, 0, this.buffer, this.readLen, len);
                this.readLen += len;
            }
            if (!this.readOK) {
                GENELog.log(GENEConstance.GENE_COMM, GENELog.ERROR, 0, "time out when recieving data!");
            }
        }

        public void beginRun() {
            this.readingThread = new Thread(this);
            this.readingThread.setName("ReceiveMsg Read thread");
            this.readingThread.start();
        }

        public String getMessage() throws GENEException {
            try {
                this.readingThread.interrupt();
            } catch (Exception unused) {
            }
            if (!this.readOK) {
                throw new GENEException("time out when recieving data!");
            }
            if (this.readLen <= 0) {
                return "";
            }
            return new String(this.buffer, 0, this.readLen);
        }

        public synchronized void readInputOk(ReceiveMsg rec) {
            rec.readOK = true;
            notifyAll();
        }

        /* JADX WARN: Multi-variable type inference failed */
        /* JADX WARN: Type inference failed for: r0v0 */
        /* JADX WARN: Type inference failed for: r0v2, types: [java.lang.Throwable] */
        /* JADX WARN: Type inference failed for: r0v5 */
        /* JADX WARN: Type inference failed for: r0v9, types: [java.lang.Object] */
        public void waitForData(int timeout) {
            ?? r0 = this;
            synchronized (r0) {
                try {
                    r0 = this;
                    r0.wait(timeout);
                } catch (Exception e) {
                    System.out.println("Error in waiting: ".concat(String.valueOf(e)));
                }
                if (!this.readOK) {
                    this.isStop = true;
                    this.readingThread.notify();
                }
                r0 = r0;
            }
        }
    }
}
